var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result) __defProp(target, key, result);
  return result;
};

// src/index.ts
import { LitElement, html } from "lit";
import { customElement, property } from "lit/decorators.js";
import { map } from "lit/directives/map.js";
var Pagination = class extends LitElement {
  constructor() {
    super(...arguments);
    this.pageIndex = 0;
    this.totalPage = 0;
    this.onChange = (_i) => {
    };
  }
  onClick(e) {
    const target = e.target;
    if (target?.tagName === "UI5-BUTTON") {
      const to = parseInt(target.dataset.to) || 0;
      if (this.renderRoot.dispatchEvent(new CustomEvent("pagination-click", {
        bubbles: true,
        composed: true,
        detail: to,
        cancelable: true
      })))
        this.onChange?.(this.pageIndex = to);
    }
  }
  render() {
    return html`<span style="display:inline-flex;gap:4px" @click=${this.onClick}>
            <ui5-button
                design="Emphasized"
                icon="navigation-left-arrow"
                ?disabled="${this.totalPage == 0 || this.pageIndex == 0}"
                data-to=${this.pageIndex}
            ></ui5-button>
        ${map(Array(this.totalPage), (_, i) => {
      if (i === this.pageIndex)
        return html`<ui5-button design="Emphasized" disabled>${i + 1}</ui5-button>`;
      if (this.totalPage < 8 || Math.abs(i - this.pageIndex) < Math.max(
        5 - this.pageIndex,
        6 - this.totalPage + this.pageIndex,
        2
      ) || i == 1 && this.pageIndex == 3 || i == this.totalPage - 2 && this.pageIndex == this.totalPage - 4)
        return html`<ui5-button design="Default" data-to=${i}>${i + 1}</ui5-button>`;
      if (i === 0)
        return html`<ui5-button design="Default" data-to="0">1</ui5-button>`;
      if (i === this.totalPage - 1)
        return html`<ui5-button design="Default" data-to=${i}>${this.totalPage}</ui5-button>`;
      if (i === 1)
        return html`<ui5-button design="Transparent" disabled>...</ui5-button>`;
      if (i === this.totalPage - 2)
        return html`<ui5-button design="Transparent" disabled>...</ui5-button>`;
    })}
            <ui5-button
                design="Emphasized"
                icon="navigation-right-arrow"
                ?disabled="${this.totalPage == 0 || this.pageIndex == this.totalPage - 1}"
                data-to=${this.pageIndex + 1}
            ></ui5-button>
        </span>`;
  }
};
__decorateClass([
  property({ type: Number })
], Pagination.prototype, "pageIndex", 2);
__decorateClass([
  property({ type: Number })
], Pagination.prototype, "totalPage", 2);
__decorateClass([
  property({ type: Function })
], Pagination.prototype, "onChange", 2);
Pagination = __decorateClass([
  customElement("ui5-pagination")
], Pagination);
export {
  Pagination
};
